import java.awt.*;
import java.applet.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.net.*;

/**
 * BinaryConverter.java 1.0 02/11/01
 * <br>
 * Author       : James McMahon
 * <br>
 * BinaryConverter Help Panel Class
 * <br>
 * Provides a help screen for users
 * <br>
 * Created      : 1/11/2001
 * <br>
 * Last Updated : 1/11/2001
 */

public class HelpPanel extends JEditorPane {
	
	/**
	 * Needed because we have a JOptionPane that is model to the main applet
	 */
	private BinaryConverter parent; 
	
	/**
	 *
	 */
	private String pageName = "help.html"; // name of the help file
	
	/**
	 *  The url string that is later converted to the helpURL
	 */
	private String url = "";
	
	/**
	 * The url of the html help page
	 */
	private URL helpURL = null;
	
	/**
	 * Creates and shows a html help page that is model to parentOwner
	 *
	 * @param parentOwner The main applet class
	 */
	public HelpPanel(BinaryConverter parentOwner) {
		
		parent = parentOwner;

		this.setEditable(false);
	
		try {
			
			url = parent.getCodeBase()+pageName;
			helpURL = new URL(url);
			this.setPage(helpURL);
			
			JScrollPane helpPanel = new JScrollPane(this);
			helpPanel.setPreferredSize(new Dimension(540,300));
			
			JOptionPane.showMessageDialog(parent,
						  helpPanel,
				          "Binary Conversion Help File",
				          JOptionPane.PLAIN_MESSAGE);			
	
		} catch(Exception ioe) { 
			//This is strange - if I catch the IOException that is supposed to be thrown then
			//it seems to ignore the actual exception that is generated - hence catching the general exception
			//is the only sure way of making the dialog being shown
			
			//So got a problem here with trying to open the html help page
			JOptionPane.showMessageDialog(parent,
						  "The help page can't be found - sorry!",
				          "Sorry there has been an error",
				          JOptionPane.ERROR_MESSAGE);
		}
	}	
}