import java.awt.*;
import java.applet.*;
import javax.swing.*;

/**
 * BinaryConverter.java 1.0 02/11/01
 * <br>
 * Author       : James McMahon
 * <br>
 * BinaryConverter Applet Class
 * <br>
 * Temporary Workspace for user to calculate there answer to a question
 * <br>
 * Created      : 1/11/2001
 * <br>
 * Last Updated : 1/11/2001
 */

public class TempWorkSpace extends JPanel {
	
		private BinaryConverter parent; //The parent of this class. 
					//Used exclusively to find the number for conversion from the questionpanel
					//Should probably pass the value into the constructor instead! STUBBED 
	
		//The sum boxes
		private	JTextField one 	 = new JTextField(5);
		private JTextField two	 = new JTextField(5);
		private JTextField three = new JTextField(5);
		private JTextField four	 = new JTextField(5);
		private JTextField five	 = new JTextField(5);
		private JTextField six	 = new JTextField(5);
		private JTextField seven = new JTextField(5);
		private JTextField eight = new JTextField(5);
			
		//the answer boxes
		private JTextField ansOne   = new JTextField(4);
		private JTextField ansTwo   = new JTextField(4);
		private JTextField ansThree = new JTextField(4);
		private JTextField ansFour  = new JTextField(4);
		private JTextField ansFive 	= new JTextField(4);
		private JTextField ansSix 	= new JTextField(4);
		private JTextField ansSeven	= new JTextField(4);
		private JTextField ansEight	= new JTextField(4);	
		
		//the remainder boxes
		private JTextField remainderOne   = new JTextField(2);
		private JTextField remainderTwo   = new JTextField(2);
		private JTextField remainderThree = new JTextField(2);
		private JTextField remainderFour  = new JTextField(2);
		private JTextField remainderFive  = new JTextField(2);
		private JTextField remainderSix   = new JTextField(2);
		private JTextField remainderSeven = new JTextField(2);
		private JTextField remainderEight = new JTextField(2);
			
		//arrays of the text boxes to make them easier to access
		private Object[] sumBoxes       = {one, two, three, four, five, six, seven, eight};
		private Object[] answerBoxes    = {ansOne, ansTwo, ansThree, ansFour, ansFive, ansSix, ansSeven, ansEight};
		private Object[] remainderBoxes = {remainderOne,remainderTwo, remainderThree, remainderFour, remainderFive, remainderSix, remainderSeven, remainderEight};
		
		//Static labels that need to be defined individually otherwise swing messes up 
		//when you try to be clear and place one in many locations!
		private JLabel equals1 = new JLabel(" = ");
		private JLabel equals2 = new JLabel(" = ");
		private JLabel equals3 = new JLabel(" = ");
		private JLabel equals4 = new JLabel(" = ");
		private JLabel equals5 = new JLabel(" = ");
		private JLabel equals6 = new JLabel(" = ");
		private JLabel equals7 = new JLabel(" = ");
		private JLabel equals8 = new JLabel(" = ");
		private JLabel equals9 = new JLabel(" = ");
		
		private JLabel remainder1 = new JLabel(" r ");
		private JLabel remainder2 = new JLabel(" r ");
		private JLabel remainder3 = new JLabel(" r ");
		private JLabel remainder4 = new JLabel(" r ");
		private JLabel remainder5 = new JLabel(" r ");
		private JLabel remainder6 = new JLabel(" r ");
		private JLabel remainder7 = new JLabel(" r ");
		private JLabel remainder8 = new JLabel(" r ");
	
		//The layout manager for this panel
		private GridBagLayout gridBag;
		private GridBagConstraints cons;
	
		/** 
		 * Constructs the workspace and uses the parentOwner applet class for accessing the other panels
		 * 
		 * @param parentOwner Currently needed only for access to the current question that is being asked
		 */
		public TempWorkSpace(BinaryConverter parentOwner) {
				
			parent = parentOwner;
			
			setBorder(BorderFactory.createTitledBorder("WorkSpace Area"));
			
			//Use gridbag layout because of all of the different items to be displayed in here
			gridBag = new GridBagLayout();
			setLayout(gridBag);
			
			this.setToolTipText("Space for working out answers N.B. Not used in answer checking!");
			
			displaySumFields();
			displayEquals();
			displayAnswerFields();
			displayRemainders();
			displayRemainderFields();
		}	
		
		/** 
		 * Sets up the sum fields on the screen and displays them
		 */
		public void displaySumFields() {
			
			cons = getDefaultConstraints();
			
			cons.gridx = 0;
	        cons.gridy = 0;
			gridBag.setConstraints(one, cons);
			add(one);

			cons.gridx = 0;
	    	cons.gridy = 1;
			gridBag.setConstraints(two, cons);
			add(two);

			cons.gridx = 0;
	    	cons.gridy = 2;
			gridBag.setConstraints(three, cons);
			add(three);
			
			cons.gridx = 0;
	    	cons.gridy = 3;
			gridBag.setConstraints(four, cons);
			add(four);
			
			cons.gridx = 0;
	    	cons.gridy = 4;
			gridBag.setConstraints(five, cons);
			add(five);
			
			cons.gridx = 0;
	    	cons.gridy = 5;
			gridBag.setConstraints(six, cons);
			add(six);
			
			cons.gridx = 0;
	    	cons.gridy = 6;	
			gridBag.setConstraints(seven, cons);
			add(seven);
			
			cons.gridx = 0;
	    	cons.gridy = 7;
			gridBag.setConstraints(eight, cons);
			add(eight);
			
		}
		
		/** 
		 * Sets up the "=" text on the screen and displays them
		 */
		public void displayEquals() {
			cons = getDefaultConstraints();
		
			cons.gridx = 1;
	        cons.gridy = 0;
	        gridBag.setConstraints(equals1, cons);
			add(equals1);
			
			cons.gridx = 1;
	        cons.gridy = 1;
	        gridBag.setConstraints(equals2, cons);
			add(equals2);
			
			cons.gridx = 1;
	        cons.gridy = 2;
	        gridBag.setConstraints(equals3, cons);
			add(equals3);
			
			cons.gridx = 1;
	        cons.gridy = 3;
	        gridBag.setConstraints(equals4, cons);
			add(equals4);
						
				cons.gridx = 1;
	        cons.gridy = 4;
	        gridBag.setConstraints(equals5, cons);
			add(equals5);
			
			cons.gridx = 1;
	        cons.gridy = 5;
	        gridBag.setConstraints(equals6, cons);
			add(equals6);
			
			cons.gridx = 1;
	        cons.gridy = 6;
	        gridBag.setConstraints(equals7, cons);
			add(equals7);
			
			cons.gridx = 1;
	        cons.gridy = 7;
	        gridBag.setConstraints(equals8, cons);
			add(equals8);
		}
		
		/** 
		 * Sets up the answer fields and displays them on the screen
		 */
		public void displayAnswerFields() {
			
			cons = getDefaultConstraints();
			
			cons.gridx = 2;
	        cons.gridy = 0;
			gridBag.setConstraints(ansOne, cons);
			add(ansOne);

			cons.gridx = 2;
	    	cons.gridy = 1;
			gridBag.setConstraints(ansTwo, cons);
			add(ansTwo);

			cons.gridx = 2;
	    	cons.gridy = 2;
			gridBag.setConstraints(ansThree, cons);
			add(ansThree);
			
			cons.gridx = 2;
	    	cons.gridy = 3;
			gridBag.setConstraints(ansFour, cons);
			add(ansFour);
			
			cons.gridx = 2;
	    	cons.gridy = 4;
			gridBag.setConstraints(ansFive, cons);
			add(ansFive);
			
			cons.gridx = 2;
	    	cons.gridy = 5;
			gridBag.setConstraints(ansSix, cons);
			add(ansSix);
			
			cons.gridx = 2;
	    	cons.gridy = 6;	
			gridBag.setConstraints(ansSeven, cons);
			add(ansSeven);
			
			cons.gridx = 2;
	    	cons.gridy = 7;
			gridBag.setConstraints(ansEight, cons);
			add(ansEight);
		}
		
		/** 
		 * Sets up the remainder 'R' letter's on to the screen
		 */
		public void displayRemainders() {
			cons = getDefaultConstraints();
			
			cons.gridx = 3;
	        cons.gridy = 0;
			gridBag.setConstraints(remainder1, cons);
			add(remainder1);

			cons.gridx = 3;
	    	cons.gridy = 1;
			gridBag.setConstraints(remainder2, cons);
			add(remainder2);

			cons.gridx = 3;
	    	cons.gridy = 2;
			gridBag.setConstraints(remainder3, cons);
			add(remainder3);
			
			cons.gridx = 3;
	    	cons.gridy = 3;
			gridBag.setConstraints(remainder4, cons);
			add(remainder4);
			
			cons.gridx = 3;
	    	cons.gridy = 4;
			gridBag.setConstraints(remainder5, cons);
			add(remainder5);
			
			cons.gridx = 3;
	    	cons.gridy = 5;
			gridBag.setConstraints(remainder6, cons);
			add(remainder6);
			
			cons.gridx = 3;
	    	cons.gridy = 6;	
			gridBag.setConstraints(remainder7, cons);
			add(remainder7);
			
			cons.gridx = 3;
	    	cons.gridy = 7;
			gridBag.setConstraints(remainder8, cons);
			add(remainder8);
			
		}
		
		/** 
		 * Sets up the remainder fields and places them on to the screen
		 */
		public void displayRemainderFields() {
		
			cons = getDefaultConstraints();
			
			cons.gridx = 4;
	        cons.gridy = 0;
			gridBag.setConstraints(remainderOne, cons);
			add(remainderOne);

			cons.gridx = 4;
	    	cons.gridy = 1;
			gridBag.setConstraints(remainderTwo, cons);
			add(remainderTwo);

			cons.gridx = 4;
	    	cons.gridy = 2;
			gridBag.setConstraints(remainderThree, cons);
			add(remainderThree);
			
			cons.gridx = 4;
	    	cons.gridy = 3;
			gridBag.setConstraints(remainderFour, cons);
			add(remainderFour);
			
			cons.gridx = 4;
	    	cons.gridy = 4;
			gridBag.setConstraints(remainderFive, cons);
			add(remainderFive);
			
			cons.gridx = 4;
	    	cons.gridy = 5;
			gridBag.setConstraints(remainderSix, cons);
			add(remainderSix);
			
			cons.gridx = 4;
	    	cons.gridy = 6;	
			gridBag.setConstraints(remainderSeven, cons);
			add(remainderSeven);
			
			cons.gridx = 4;
	    	cons.gridy = 7;
			gridBag.setConstraints(remainderEight, cons);
			add(remainderEight);
		}
	
		/** 
		 * Should fill in the sum boxes to give X/2, (X/2)/2 etc
		 * <br>
		 * Gives only the sums that need to be completed and not the full solution
		 */
		public void giveHint() {

			int decimalNumber =	parent.getQuestionPanel().getNumberForConversion();
			int iteration = 0;
			
			clearFields();//First off clear all of the fields to give blank boxes to work with

			// loop until the number has reached zero
			// at every iteration set the value of the sum to the answerField 
			// that corresponds to it
			//
			// Ensures that only eight boxes are ever filled in and 0/2 is never set
			while ((decimalNumber != 0) && (iteration<8)) {
				//get the field that relates to the curent iteration and set the number
				((JTextField)sumBoxes[iteration]).setText(""+decimalNumber+"/2");
				decimalNumber = decimalNumber/2; //calculate the next one
				iteration+=1;//filled in a box so update iteration
			}
		}
		
		/** 
		 * Completes the entire workspace column with the full solution
		 */
		public void showFullWorking() {
		
			int decimalNumber =	parent.getQuestionPanel().getNumberForConversion();
			int iteration = 0;
			
			int sum		  = 0;
			int remainder = 0;
			int answer	  = decimalNumber;

			// loop until the number has reached zero
			// at every iteration set the value of the boxes to the right answer 
			// that corresponds to it
			//
			// Ensures that only eight boxes are ever filled in and 0/2 will be set
			
			while (iteration<8) {
				
				//calculate the remainder first
				remainder = answer % 2; 		
				
				//get the field that relates to the curent iteration and set the number
				((JTextField)sumBoxes[iteration]).setText(""+answer+"/2");
				((JTextField)answerBoxes[iteration]).setText(""+(answer/2));
				((JTextField)remainderBoxes[iteration]).setText(""+remainder);
			
				answer    = answer / 2;//Calculate the answer here
				iteration+=1;//filled in a box so update iteration
			}	
		}
	
		/** 
		 * Clears the fields of the workspace to null
		 */
		public void clearFields() {
		
			//clear the sum fields
			one.setText("");
			two.setText("");
			three.setText("");
			four.setText("");	
	 		five.setText("");
			six.setText("");
	 		seven.setText("");
		 	eight.setText("");
			
			//clear the answer fields
			ansOne.setText("");
		 	ansTwo.setText("");
		 	ansThree.setText("");
			ansFour.setText("");
	 		ansFive.setText("");
	 		ansSix.setText("");
	 		ansSeven.setText("");
		 	ansEight.setText("");
		
			//clear the remainder fields
			remainderOne.setText("");
			remainderTwo.setText("");
		 	remainderThree.setText("");
		 	remainderFour.setText("");
			remainderFive.setText("");
			remainderSix.setText("");
			remainderSeven.setText("");
			remainderEight.setText("");
		}
		
	/**
	 * Gets the Default constraints
	 * 
	 * @return   GridBagConstraints The default constraints
	 */
	private GridBagConstraints getDefaultConstraints()
	{
		GridBagConstraints con = new GridBagConstraints();

		con.anchor     = GridBagConstraints.NORTH;
		con.fill       = GridBagConstraints.NONE;
		con.gridheight = 1;
		con.gridwidth  = 1;
		con.gridx      = GridBagConstraints.RELATIVE;
		con.gridy      = GridBagConstraints.RELATIVE;
		con.insets     = new Insets(1, 1, 1, 1);
		con.ipadx      = 0;
		con.ipady      = 0;
		con.weightx    = 0;
		con.weighty    = 0;

		return con;
	}
	
}